package com.infosynergi.testbyggestr;

import java.io.IOException;
import java.io.OutputStream;
import javax.xml.bind.JAXBException;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.TransformerException;
import org.apache.xpath.XPathAPI;
import org.apache.xpath.objects.XObject;
import org.docx4j.TextUtils;
import org.docx4j.XmlUtils;
import org.docx4j.convert.out.html.AbstractHtmlExporter;
import org.docx4j.convert.out.html.HtmlExporterNG2;
import org.docx4j.fonts.IdentityPlusMapper;
import org.docx4j.model.datastorage.CustomXmlDataStorage;
import org.docx4j.openpackaging.exceptions.Docx4JException;
import org.docx4j.openpackaging.packages.WordprocessingMLPackage;
import org.docx4j.openpackaging.parts.CustomXmlDataStoragePart;
import org.docx4j.openpackaging.parts.WordprocessingML.DocumentPart;
import org.docx4j.openpackaging.parts.WordprocessingML.MainDocumentPart;
import org.w3c.dom.Document;
import org.w3c.dom.DocumentType;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

/**
 * Hello world!
 *
 */
public class ProcessTemplate
{
    @SuppressWarnings("static-access")
    public static void main( String[] args ) throws Docx4JException, SAXException, IOException, ParserConfigurationException, TransformerException, JAXBException, Exception
    {
        WordprocessingMLPackage wordMLPackage = WordprocessingMLPackage.load(new java.io.File("c:\\byggestrnew.docx"));
        MainDocumentPart docPart = wordMLPackage.getMainDocumentPart();
        Document doc = XmlUtils.marshaltoW3CDomDocument(docPart.getJaxbElement());
        Document data = DocumentBuilderFactory.newInstance().newDocumentBuilder().parse("c:\\byggestr.xml");
        addTableRowsNew(doc, data);
        docPart.setJaxbElement((org.docx4j.wml.Document)XmlUtils.unmarshal(doc));
        CustomXmlDataStoragePart customXmlDataStoragePart = (CustomXmlDataStoragePart) wordMLPackage.getCustomXmlDataStorageParts().entrySet().iterator().next().getValue();
        //CustomXmlDataStoragePart customXmlDataStoragePart = (CustomXmlDataStoragePart) wordMLPackage.getCustomXmlDataStorageParts().get("{A61EE2AE-F111-4B83-8C9C-F3BECEA1AD12}");
        CustomXmlDataStorage customXmlDataStorage = customXmlDataStoragePart.getData();
        customXmlDataStorage.setDocument(data);
        wordMLPackage.save(new java.io.File("c:\\fkf.docx"));
        //customXmlDataStoragePart.applyBindings(docPart);

        //Text
        java.io.FileWriter fw = new java.io.FileWriter("c:\\fkf.txt");
        TextUtils.extractText((org.docx4j.wml.Document)wordMLPackage.getMainDocumentPart().getJaxbElement(), fw);
        fw.flush();
        fw.close();


        //HTML 
        AbstractHtmlExporter exporter = new HtmlExporterNG2();
        exporter.setWmlPackage(wordMLPackage);
        OutputStream os = new java.io.FileOutputStream("c:\\fkf.html");
        javax.xml.transform.stream.StreamResult result = new javax.xml.transform.stream.StreamResult(os);
        exporter.output(result);


        //PDF 
        // Set up converter
        org.docx4j.convert.out.pdf.PdfConversion c = new org.docx4j.convert.out.pdf.viaXSLFO.Conversion(wordMLPackage);
        // Write to output stream
        OutputStream ospdf = new java.io.FileOutputStream("c:\\fkf.pdf");
        c.output(ospdf);

    }

    private static void addTableRowsNew(Document doc, Document data) throws TransformerException
    {
        NodeList tableNodeList = XPathAPI.selectNodeList(doc, "./w:document/w:body/w:tbl");
        for (int i = 0; i < tableNodeList.getLength(); i++)
        {
            Node tableNode = tableNodeList.item(i);
            Node tableCellProcSdtPropNode = XPathAPI.selectSingleNode(tableNode, "./w:tr[2]/w:tc[1]/w:sdt/w:sdtPr/w:tag");
            if (tableCellProcSdtPropNode != null)
            {
                String tag = tableCellProcSdtPropNode.getAttributes().getNamedItem("w:val").getNodeValue();
                if (tag.contains("/"))
                {
                    XObject cntObject = XPathAPI.eval(data, "count(" + tag + ")");
                    int count = (int) cntObject.num();
                    System.out.println("Count = " + count);
                    if (count > 1)
                    {
                        NamedNodeMap attributes = tableCellProcSdtPropNode.getAttributes();
                        for (int n = 0; n < attributes.getLength() ; n++)
                        {
                            Node attr = attributes.item(n);
                            if (attr.getNodeName().equals("w:val"))
                            {
                                for (int k = 2; k <= count; k++)
                                {
                                    Node newRowNode = tableNode.appendChild(XPathAPI.selectSingleNode(tableNode, "./w:tr[2]").cloneNode(true));
                                    NodeList cellNodeList = XPathAPI.selectNodeList(newRowNode, "./w:tc");
                                    for (int l = 0; l < cellNodeList.getLength() ; l++)
                                    {
                                        Node cellNode = cellNodeList.item(l);
                                        Node dataBindingNode = XPathAPI.selectSingleNode(cellNode, "./w:sdt/w:sdtPr/w:dataBinding");
                                        NamedNodeMap cellNodeAttr = dataBindingNode.getAttributes();
                                        for (int m = 0; m < cellNodeAttr.getLength(); m++)
                                        {
                                            Node bindAttr = cellNodeAttr.item(m);
                                            if (bindAttr.getNodeName().equals("w:xpath"))
                                            {
                                                String firstxpath = bindAttr.getNodeValue().substring(0, tag.length()+1);
                                                String lastxpath = bindAttr.getNodeValue().substring(tag.length()+2);
                                                bindAttr.setNodeValue(firstxpath + k + lastxpath);
                                            }
                                        }
                                        XPathAPI.selectSingleNode(cellNode, "./w:sdt/w:sdtPr").removeChild(XPathAPI.selectSingleNode(cellNode, "./w:sdt/w:sdtPr/w:id"));
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    }

    private static void addTableRows(Document doc, Document data) throws TransformerException
    {
        NodeList sdtNodeList = XPathAPI.selectNodeList(doc, "./w:document/w:body/w:sdt");
        for (int i = 0; i < sdtNodeList.getLength(); i++)
        {
            Node sdtNode = sdtNodeList.item(i);
            Node tagNode = XPathAPI.selectSingleNode(sdtNode, "./w:sdtPr/w:tag");
            String tag = tagNode.getAttributes().getNamedItem("w:val").getNodeValue();
            Node aliasNode = XPathAPI.selectSingleNode(sdtNode, "./w:sdtPr/w:alias");
            String title = aliasNode.getAttributes().getNamedItem("w:val").getNodeValue();
            if (title.equalsIgnoreCase("TABELL"))
            {
                XObject cntObject = XPathAPI.eval(data, "count(" + tag + ")");
                int count = (int) cntObject.num();
                System.out.println("Count = " + count);
                if (count > 1)
                {
                    NodeList tableNodeList = XPathAPI.selectNodeList(sdtNode, "./w:sdtContent/w:tbl");
                    for (int j = 0; j < tableNodeList.getLength(); j++)
                    {
                        Node tableNode = tableNodeList.item(j);
                        Node tableCellProcSdtPropNode = XPathAPI.selectSingleNode(tableNode, "./w:tr[2]/w:tc[1]/w:sdt/w:sdtPr/w:tag");
                        if (tableCellProcSdtPropNode != null)
                        {
                            NamedNodeMap attributes = tableCellProcSdtPropNode.getAttributes();
                            for (int n = 0; n < attributes.getLength() ; n++)
                            {
                                Node attr = attributes.item(n);
                                if (attr.getNodeName().equals("w:val"))
                                {
                                    for (int k = 2; k <= count; k++)
                                    {
                                        Node newRowNode = tableNode.appendChild(XPathAPI.selectSingleNode(tableNode, "./w:tr[2]").cloneNode(true));
                                        NodeList cellNodeList = XPathAPI.selectNodeList(newRowNode, "./w:tc");
                                        for (int l = 0; l < cellNodeList.getLength() ; l++)
                                        {
                                            Node cellNode = cellNodeList.item(l);
                                            Node dataBindingNode = XPathAPI.selectSingleNode(cellNode, "./w:sdt/w:sdtPr/w:dataBinding");
                                            NamedNodeMap cellNodeAttr = dataBindingNode.getAttributes();
                                            for (int m = 0; m < cellNodeAttr.getLength(); m++)
                                            {
                                                Node bindAttr = cellNodeAttr.item(m);
                                                if (bindAttr.getNodeName().equals("w:xpath"))
                                                {
                                                    String firstxpath = bindAttr.getNodeValue().substring(0, tag.length()+1);
                                                    String lastxpath = bindAttr.getNodeValue().substring(tag.length()+2);
                                                    bindAttr.setNodeValue(firstxpath + k + lastxpath);
                                                }
                                            }
                                            XPathAPI.selectSingleNode(cellNode, "./w:sdt/w:sdtPr").removeChild(XPathAPI.selectSingleNode(cellNode, "./w:sdt/w:sdtPr/w:id"));
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    }

    public static void printNode(Node node, String indent) {
		switch (node.getNodeType()) {
		case Node.DOCUMENT_NODE:
			System.out.println(indent + "<?xml version=\"1.0\"?>");

			NodeList nodes = node.getChildNodes();

			if (nodes != null) {
				for (int i = 0; i < nodes.getLength(); i++) {
					printNode(nodes.item(i), "");
				}
			}

			break;

		case Node.ELEMENT_NODE:

			String name = node.getNodeName();
			System.out.print(indent + "<" + name);

			NamedNodeMap attributes = node.getAttributes();

			for (int i = 0; i < attributes.getLength(); i++) {
				Node current = attributes.item(i);
				System.out.print(" " + current.getNodeName() +
				        "=\"" + current.getNodeValue() + "\"");
			}

			System.out.println(">");

			NodeList children = node.getChildNodes();

			if (children != null) {
				for (int i = 0; i < children.getLength();
					        i++) {
					printNode(children.item(i),
					        indent + "  ");
				}
			}

			System.out.println(indent + "</" + name + ">");

			break;

		case Node.TEXT_NODE:
		case Node.CDATA_SECTION_NODE:
			System.out.println(indent + node.getNodeValue());

			break;

		case Node.PROCESSING_INSTRUCTION_NODE:
			System.out.println(indent + "<?" + node.getNodeName() +
			        " " + node.getNodeValue() + " ?>");

			break;

		case Node.ENTITY_REFERENCE_NODE:
			System.out.println("&" + node.getNodeName() + ";");

			break;

		case Node.DOCUMENT_TYPE_NODE:

			DocumentType docType = (DocumentType) node;
			System.out.print("<!DOCTYPE " + docType.getName());

			if (docType.getPublicId() != null) {
				System.out.print("PUBLIC \"" +
				        docType.getPublicId() + "\"");
			} else {
				System.out.print(" SYSTEM ");
			}

			System.out.println("\"" + docType.getSystemId() +
			        "\" >");

			break;
		}
	}
}
